package outlab3;

import edu.princeton.cs.algs4.In;
import edu.princeton.cs.algs4.StdOut;

/**
 * @author Ben Miller
 * @author Lauren Helbling
 */
public class MyGPS {
    public static void shortestPath(int start, int finish, WeightedGraph map) {
        long time = System.currentTimeMillis();

        Djikstra djikstra = new Djikstra(map, start);
        StdOut.println();
        StdOut.println("Shortest path from " + start + " to " + finish + ":");
        StdOut.println(djikstra.pathTo(finish));
        StdOut.println("total distance: " + djikstra.getDistance(finish));
        StdOut.println("time to find: " + (System.currentTimeMillis() - time) + " milliseconds");
        StdOut.println();
    }

    public static void main(String[] args) {
        boolean exit = false;
        In file = new In(args[0]);
        WeightedGraph map = new WeightedGraph(file);
        file.close();
        StdOut.println();
        StdOut.println("The current graph has vertices from 1 to " + map.getNumVertices());
        StdOut.println("The current graph has " + map.getNumEdges() + " edges");

        In userInput = new In();
        while (!exit) {
            StdOut.println("Would you like to:");
            StdOut.println("     1. Find a new route");
            StdOut.println("     2. Print Graph");
            StdOut.println("     3. Exit");
            int input = userInput.readInt();
            if (input == 1) {
                StdOut.print("Input source vertex number: ");
                int start = userInput.readInt();
                StdOut.print("Input destination vertex number: ");
                int finish = userInput.readInt();
                shortestPath(start, finish, map);
            } else if (input == 2) {
                StdOut.println();
                map.printGraph();
                StdOut.println();
            } else {
                exit = true;
            }
        }
    }
}
