package outlab3;

import edu.princeton.cs.algs4.In;

import java.util.LinkedList;

/**
 * @author Ben Miller
 * @author Lauren Helbling
 */
public class WeightedGraph {

    int numVertices;
    int numEdges;
    LinkedList<Edge>[] adjacencylist;

    WeightedGraph(In file) {
        while (file.hasNextLine()) {
            String tempLine = file.readLine();
            String[] edge = tempLine.split(" ");
            if (edge[0].equals("p")) {
                this.numVertices = Integer.parseInt(edge[2]) + 1;
                this.numEdges = Integer.parseInt(edge[3]);
                this.adjacencylist = new LinkedList[numVertices];
                for (int i = 0; i < numVertices; i++) {
                    this.adjacencylist[i] = new LinkedList<>();
                }
            } else if (edge[0].equals("a")) {
                Edge newEdge = new Edge(Integer.parseInt(edge[1]), Integer.parseInt(edge[2]),
                        Double.parseDouble(edge[3]));
                adjacencylist[Integer.parseInt(edge[1])].addFirst(newEdge);
            }
        }
    }

    public void printGraph() {
        for (int i = 0; i < numVertices; i++) {
            LinkedList<Edge> list = adjacencylist[i];
            for (int j = 0; j < list.size(); j++) {
                System.out.println("vertex-" + i + " is connected to " + list.get(j).finish + " with weight "
                        + list.get(j).weight);
            }
        }
    }

    public int getNumEdges() {
        return numEdges;
    }

    public LinkedList<Edge>[] getAdjacencylist() {
        return adjacencylist;
    }

    public int getNumVertices() {
        return this.numVertices - 1;
    }

    public Edge[] getEdgeArray() {
        Edge[] edgeArray = new Edge[getNumEdges()];
        int index = 0;
        for (int i = 0; i < numVertices; i++) {
            LinkedList<Edge> list = adjacencylist[i];
            for (int j = 0; j < list.size(); j++) {
                edgeArray[index++] = list.get(j);
            }
        }
        return edgeArray;
    }
}
